'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _memoizee = require('memoizee');

var _memoizee2 = _interopRequireDefault(_memoizee);

var _q = require('q');

var _q2 = _interopRequireDefault(_q);

var _modulesMain = require('./modules/main');

var _modulesMain2 = _interopRequireDefault(_modulesMain);

/**
 * [TflLineStatus description]
 */

var _default = (function () {
  function _default() {
    _classCallCheck(this, _default);

    this._lines = _lodash2['default'].keys(_modulesMain2['default'].mapCode.codeToId);

    this.getAllStatuses = (0, _memoizee2['default'])(this._getAllStatuses.bind(this), {
      length: 1,
      maxAge: 30000,
      preFetch: 0.1,
      primitive: true,
      promise: true
    });
  }

  _createClass(_default, [{
    key: 'getLines',
    value: function getLines() {
      return this._lines;
    }
  }, {
    key: 'setLines',
    value: function setLines(lines) {
      if (_lodash2['default'].isArray(lines) && !_lodash2['default'].isEmpty(lines)) {
        this._lines = lines;
      }
    }
  }, {
    key: 'getLineStatusByCode',
    value: function getLineStatusByCode(code) {
      return this.getAllStatuses().then(function (res) {
        return _lodash2['default'].find(res, { 'code': code });
      });
    }
  }, {
    key: 'getLineStatus',
    value: function getLineStatus() {
      var code = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];

      if (_lodash2['default'].isString(code) && !_lodash2['default'].isEmpty(code)) {
        return this.getLineStatusByCode(code);
      }

      return this.getAllStatuses();
    }

    // private methods

  }, {
    key: '_getAllStatuses',
    value: function _getAllStatuses() {
      var deferred = _q2['default'].defer();

      _modulesMain2['default'].loadLineStatusXML(function (err, feed) {
        if (err) {
          deferred.reject(err);
          return;
        }

        try {
          var result = _modulesMain2['default'].mapLineStatus(feed);
          deferred.resolve(result);
        } catch (e) {
          deferred.reject(e);
        }
      });

      return deferred.promise;
    }
  }]);

  return _default;
})();

exports['default'] = _default;
module.exports = exports['default'];