'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = mapLineStatus;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _mapCode = require('./mapCode');

var _mapCode2 = _interopRequireDefault(_mapCode);

/**
 * [parseLineStatus description]
 * @param  {Object}
 */

function mapLineStatus(feed) {
  if (!_lodash2['default'].isObject(feed)) {
    throw new Error('feed is not an Object');
  }

  if (!_lodash2['default'].isObject(feed.ArrayOfLineStatus)) {
    throw new Error('ArrayOfLineStatus is not an Object');
  }

  if (!_lodash2['default'].isArray(feed.ArrayOfLineStatus.LineStatus)) {
    throw new Error('LineStatus is not an Array');
  }

  return _lodash2['default'].map(feed.ArrayOfLineStatus.LineStatus, function (lineStatus) {
    return {
      id: lineStatus.Line.$.ID,
      code: _mapCode2['default'].idToCode[lineStatus.Line.$.ID],
      name: lineStatus.Line.$.Name.toLowerCase(),
      status: lineStatus.Status.$.ID,
      desc: lineStatus.Status.$.Description,
      details: lineStatus.$.StatusDetails,
      active: lineStatus.Status.$.IsActive.toLowerCase() === 'true'
    };
  });
}

module.exports = exports['default'];